#include "syscalls.h"

#define BYTES_PER_LINE (8)


const int stdout = 1;
const char *map = "0123456789abcdef";

/* sdileny buffer v neinicializovane casti pameti */
#define OUTPUT_BUFFER_SIZE	(BYTES_PER_LINE * 3 + BYTES_PER_LINE + 2)

char output_buffer[OUTPUT_BUFFER_SIZE];

void uchar_to_str(char *buf, unsigned char c)
{
	buf[0] = map[c >> 4];
	buf[1] = map[c & 0xf];
}

static void mem_dump_line_byte(int index, unsigned char val)
{
	uchar_to_str(output_buffer + index * 3, val);

	output_buffer[index * 3 + 2] = ' ';
	output_buffer[BYTES_PER_LINE * 3 + 1 + index] = (val < 32) ? '.' : val;
}

static void mem_dump_line_emptybyte(int index)
{
	output_buffer[index * 3]     = ' ';
	output_buffer[index * 3 + 1] = ' ';
	output_buffer[index * 3 + 2] = ' ';
	output_buffer[BYTES_PER_LINE * 3 + 1 + index] = ' ';
}

static void mem_dump_line(unsigned char *from, unsigned int size)
{
	for (int i = 0; i < OUTPUT_BUFFER_SIZE; i ++) {
		output_buffer[i] = 'M';
	}
	for (int i = 0; i < BYTES_PER_LINE; i++) {
		if (i < size) {
			mem_dump_line_byte(i, from[i]);
		} else {
			mem_dump_line_emptybyte(i);
		}
	}
	output_buffer[BYTES_PER_LINE * 3] = '|';
	output_buffer[BYTES_PER_LINE * 4 + 1] = '\n';
}

void mem_dump(unsigned char *from, unsigned int size)
{
	while (size > 0) {
		int line_size = size < BYTES_PER_LINE ? size : BYTES_PER_LINE;
		mem_dump_line(from, line_size);
		sys_write(stdout, output_buffer, OUTPUT_BUFFER_SIZE);
		from += line_size;
		size -= line_size;
	}
}

void _start()
{
	mem_dump((unsigned char *) map, 128);
	sys_exit(42);
}
